-- Azura_UA
-- Author: Mathetes tou Megalou Alexandrou
-- DateCreated: 5/11/2018 3:00:53 PM
--------------------------------------------------------------
local iAzuraCiv = GameInfoTypes["CIVILIZATION_MATHALX_AZURA_VALLA"]
local iDiva = GameInfoTypes["UNIT_MATHALX_DIVA"]
local iGG = GameInfoTypes["PROMOTION_GREAT_ADMIRAL"]
local iGA = GameInfoTypes["PROMOTION_GREAT_GENERAL"]

--local iDummyPolicy = GameInfoTypes["POLICY_C15_IROQUOIS_MOHAWK_BLOCK"]

local tGreatWorkBuildings = {};

for pBuilding in GameInfo.Buildings() do
	if pBuilding.GreatWorkCount > 0 then
		local pBuildingClass = GameInfo.BuildingClasses("Type = '" ..pBuilding.BuildingClass.. "'")()
		--Save BuildingClasses instead of BuildingTypes since GetBuildingGreatWork() calls for Classes
		tGreatWorkBuildings[pBuildingClass.ID] = pBuildingClass.Type
		--print("Added buildingclass " ..Locale.ConvertTextKey(pBuildingClass.Description).. " to Great Work building table")
	end
end

function AzuraFoodBonusOpen(iPlayer, iPolicyBranch)
	local agonistes = Players[iPlayer]
	if agonistes:GetCivilizationType() == iAzuraCiv then
		for asty in agonistes:Cities() do
			local skeuoi = 5 * asty:GetPopulation()
			for iBuildingClass, pBuildingClass in pairs(tGreatWorkBuildings) do
				skeuoi = skeuoi + asty:GetNumGreatWorksInBuilding(iBuildingClass) * 25
			end

			print("Total Food Gained: "..skeuoi)
			asty:ChangeFood(skeuoi)
		end
	end
end

function AzuraFoodBonusAdopt(iPlayer, iPolicy)
	local agonistes = Players[iPlayer]
	if agonistes:GetCivilizationType() == iAzuraCiv then
		for asty in agonistes:Cities() do
			local skeuoi = 5 * asty:GetPopulation()
			for iBuildingClass, pBuildingClass in pairs(tGreatWorkBuildings) do
				skeuoi = skeuoi + asty:GetNumGreatWorksInBuilding(iBuildingClass) * 25
			end

			print("Total Food Gained: "..skeuoi)
			asty:ChangeFood(skeuoi)
		end
	end
end

function empowerDiva(iPlayer)
	local agonistes = Players[iPlayer]
	if iPlayer ~= 63 then
		for taxeis in agonistes:Units() do
			if taxeis:GetUnitType() == iDiva then
				local dynamis = 7;
				local era = agonistes:GetCurrentEra();
				if (era == GameInfo.Eras["ERA_CLASSICAL"].ID) then
					dynamis = 9;
				end
				if (era == GameInfo.Eras["ERA_MEDIEVAL"].ID) then
					dynamis = 15;
				end
				if (era == GameInfo.Eras["ERA_RENAISSANCE"].ID) then
					dynamis = 22;
				end
				if (era == GameInfo.Eras["ERA_INDUSTRIAL"].ID) then
					dynamis = 32;
				end
				if (era == GameInfo.Eras["ERA_MODERN"].ID) then
					dynamis = 55;
				end
				if (era == GameInfo.Eras["ERA_POSTMODERN"].ID) then
					dynamis = 65;
				end
				if (era == GameInfo.Eras["ERA_FUTURE"].ID) then
					dynamis = 80;
				end
				if (era > GameInfo.Eras["ERA_FUTURE"].ID) then
					dynamis = 120;
				end
				taxeis:SetBaseCombatStrength(dynamis)
			end 
		end
	end
end

function empowerDivaCreation(iPlayer, iUnit)
	local agonistes = Players[iPlayer]
	if agonistes:IsEverAlive() then
		if agonistes:GetUnitByID(iUnit) ~= nil then
		local taxeis = agonistes:GetUnitByID(iUnit)
			if taxeis:GetUnitType() == iDiva then
				taxeis:SetHasPromotion(iGG, true)
				taxeis:SetHasPromotion(iGA, true)

				local dynamis = 7;
				local era = agonistes:GetCurrentEra();
				if (era == GameInfo.Eras["ERA_CLASSICAL"].ID) then
					dynamis = 9;
				end
				if (era == GameInfo.Eras["ERA_MEDIEVAL"].ID) then
					dynamis = 15;
				end
				if (era == GameInfo.Eras["ERA_RENAISSANCE"].ID) then
					dynamis = 22;
				end
				if (era == GameInfo.Eras["ERA_INDUSTRIAL"].ID) then
					dynamis = 32;
				end
				if (era == GameInfo.Eras["ERA_MODERN"].ID) then
					dynamis = 55;
				end
				if (era == GameInfo.Eras["ERA_POSTMODERN"].ID) then
					dynamis = 65;
				end
				if (era == GameInfo.Eras["ERA_FUTURE"].ID) then
					dynamis = 80;
				end
				if (era > GameInfo.Eras["ERA_FUTURE"].ID) then
					dynamis = 120;
				end
				taxeis:SetBaseCombatStrength(dynamis)
			end 
		end
	end
end

function AzuraDiva(iPlayer, iCity, iUnit)
	local agonistes = Players[iPlayer]
	if GameInfo.Units[iUnit].Type == "UNIT_MATHALX_DIVA" then
		if agonistes:GetCivilizationType() == iAzuraCiv then
			return true
		else
			return false
		end
	end
	return true
end

--GameEvents.CityCanTrain.Add(AzuraDiva)
GameEvents.PlayerDoTurn.Add(empowerDiva)
Events.SerialEventUnitCreated.Add(empowerDivaCreation)

local traitload = false
for iPlayer = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
	local agonistes = Players[iPlayer]
	if agonistes:GetCivilizationType() == iAzuraCiv then
		if not traitload then
			traitload = true
			GameEvents.PlayerAdoptPolicyBranch.Add(AzuraFoodBonusOpen)
			GameEvents.PlayerAdoptPolicy.Add(AzuraFoodBonusAdopt)
		end
		--if not agonistes:HasPolicy(iDummyPolicy) then
			--if Player.GrantPolicy then
				--agonistes:GrantPolicy(iDummyPolicy, true)
			--else
				--agonistes:SetNumFreePolicies(1)
				--agonistes:SetNumFreePolicies(0)
				--agonistes:SetHasPolicy(iDummyPolicy, true)
			--end
		--end
	end
end
