-- Decisions_Azura_Valla
-- Author: Mathetes tou Megalou Alexandrou
-- DateCreated: 5/24/2018 12:45:43 AM
--------------------------------------------------------------
print("Valla Decisions: loaded")
local iVallaCiv = GameInfoTypes["CIVILIZATION_MATHALX_AZURA_VALLA"]
local iDrama = GameInfoTypes["TECH_DRAMA"]
local iSongstress = GameInfoTypes["UNIT_MATHALX_HYMNOPOIOS"]
local iOdeion = GameInfoTypes["BUILDING_MATHALX_ODEION"]
local iHerodeion = GameInfoTypes["BUILDING_MATHALX_HERODEION"]
local iHerodeionDummy = GameInfoTypes["BUILDING_MATHALX_HERODEION_DUMMY"]
local iHerodeionClass = GameInfoTypes["BUILDINGCLASS_MATHALX_HERODEION"]

local iHellenisticPolicy = GameInfoTypes["POLICY_MATHALX_AZURA_HELLENISTIC_THEATRON"]

local iEligibleCiv = {}

local iHellasCiv = GameInfoTypes["CIVILIZATION_GREECE"]
local iPtolemaioiCiv = GameInfoTypes["CIVILIZATION_TCM_PTOLEMAIC"]  
local iPtolemaioiLatestCiv = GameInfoTypes["CIVILIZATION_TCM_PTOLEMIES"]
local iKleopatraCiv = GameInfoTypes["CIVILIZATION_LITE_TARCISIO_PTOLEMIES"]
local iSeleukeiaCiv = GameInfoTypes["CIVILIZATION_SELEUCID"]
local iSeleukeiaRemakeCiv = GameInfoTypes["CIVILIZATION_MC_SELEUCID"]
local iAntigonidaiCiv = GameInfoTypes["CIVILIZATION_MATHALX_ANTIGONID_MAKEDONIA"]
local iEpeirosCiv = GameInfoTypes["CIVILIZATION_DMS_EPIRUS"]
local iBaktriaCiv = GameInfoTypes["CIVILIZATION_TCM_BACTRIA"]
local iArgeadaiCiv = GameInfoTypes["CIVILIZATION_MC_MACEDON"]
local iAttalidaiCiv = GameInfoTypes["CIVILIZATION_MC_PERGAMON"]
local iAlkmaionidaiCiv = GameInfoTypes["CIVILIZATION_MC_ATHENS"]
local iAgiadaiCiv = GameInfoTypes["CIVILIZATION_MC_SPARTA"]

iEligibleCiv[0] = iHellasCiv
iEligibleCiv[1] = iPtolemaioiCiv
iEligibleCiv[2] = iKleopatraCiv
iEligibleCiv[3] = iSeleukeiaCiv
iEligibleCiv[4] = iAntigonidaiCiv
iEligibleCiv[5] = iBaktriaCiv
iEligibleCiv[6] = iArcheCiv
iEligibleCiv[7] = iEpeirosCiv
iEligibleCiv[9] = iPtolemaioiLatestCiv
iEligibleCiv[10] = iSeleukeiaRemakeCiv
iEligibleCiv[11] = iArgeadaiCiv
iEligibleCiv[12] = iAttalidaiCiv
iEligibleCiv[13] = iAlkmaionidaiCiv
iEligibleCiv[14] = iAgiadaiCiv

-------------------------------------------------------------------------------------------------------------------------
--  Theatron
-------------------------------------------------------------------------------------------------------------------------
local Decisions_MAV_Theatron = {}
	--local iCost = math.ceil(2000 * iMod)
	Decisions_MAV_Theatron.Name = "TXT_KEY_EVENT_MATHALX_AZURA_THEATRON_DECISION"
	--Decisions_MAV_Theatron.Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_MATHALX_AZURA_THEATRON_DECISION_DESC", 600, 25)
	Decisions_MAV_Theatron.Weight = 20
	HookDecisionCivilizationIcon(Decisions_MAV_Theatron, "CIVILIZATION_MATHALX_AZURA_VALLA")
	Decisions_MAV_Theatron.CanFunc = (
		function(agonistes)

			if agonistes:GetCivilizationType() ~= iVallaCiv then 
				return false, false 
			end

			local techne = 50
			local hasOdeion = false

			for asty in agonistes:Cities() do
				if asty:IsHasBuilding(iOdeion) then
					hasOdeion = true
					techne = techne + (5 * asty:GetPopulation())
				end
			end

			local iCost = math.ceil(300 * iMod)
			
			local iAccCulture = 0
			local iNeededCulture = 0
			if load(agonistes, "Azura_Theatron_Culture") ~= nil then
				iAccCulture = load(agonistes, "Azura_Theatron_Culture")
			else
				save(agonistes, "Azura_Theatron_Culture", 0)
			end
			if load(agonistes, "Azura_Theatron_Hymnopoios") ~= nil then
				iNeededCulture = math.floor(250 * (1 + load(agonistes, "Azura_Theatron_Hymnopoios")) * iMod)
			else
				save(agonistes, "Azura_Theatron_Hymnopoios", 0)
				iNeededCulture = math.floor(250 * iMod)
			end

			Decisions_MAV_Theatron.Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_MATHALX_AZURA_THEATRON_DECISION_DESC", iCost, techne, iAccCulture, iNeededCulture)

			if load(agonistes, "Decisions_MAV_Theatron") ~= nil then
				if load(agonistes, "Decisions_MAV_Theatron") >= agonistes:GetCurrentEra() then
					Decisions_MAV_Theatron.Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_MATHALX_AZURA_THEATRON_DECISION_ENACTED_DESC", iAccCulture, iNeededCulture)
					return false, false, true
				end
			end

			if not Teams[agonistes:GetTeam()]:IsHasTech(GameInfo.Technologies[iDrama].ID) then
				return true, false
			end

			if not hasOdeion then
				return true, false
			end

			if agonistes:GetGold() < iCost then
				return true, false
			end

			if agonistes:GetNumResourceAvailable(iMagistrate, false) < 1	 	
				then return true, false 
			end

			return true, true
		end
		)

	Decisions_MAV_Theatron.DoFunc = (
		function(agonistes)
			agonistes:ChangeNumResourceTotal(iMagistrate, -1)

			local iCost = math.ceil(300 * iMod)
			agonistes:ChangeGold(-iCost)

			local techne = 50

			for asty in agonistes:Cities() do
				if asty:IsHasBuilding(iOdeion) then
					techne = techne + (5 * asty:GetPopulation())
				end
			end

			agonistes:ChangeJONSCulture(techne)

			local proteuousa = agonistes:GetCapitalCity()

			save(agonistes, "Azura_Theatron_Culture", load(agonistes, "Azura_Theatron_Culture") + techne)

			if load(agonistes, "Azura_Theatron_Culture") >= math.floor(250 * (1 + load(agonistes, "Azura_Theatron_Hymnopoios")) * iMod) then
				save(agonistes, "Azura_Theatron_Culture", 0)
				save(agonistes, "Azura_Theatron_Hymnopoios", load(agonistes, "Azura_Theatron_Hymnopoios") + 1)

				agonistes:InitUnit(iSongstress, proteuousa:GetX(), proteuousa:GetY()):JumpToNearestValidPlot()
			end

			save(agonistes, "Decisions_MAV_Theatron", agonistes:GetCurrentEra())
		end
	)

Decisions_AddCivilisationSpecific(iVallaCiv, "Decisions_MAV_Theatron", Decisions_MAV_Theatron)

-------------------------------------------------------------------------------------------------------------------------
--  Hellenism
-------------------------------------------------------------------------------------------------------------------------
local Decisions_MAV_Hellenistic_Theatron = {}
	--local iCost = math.ceil(2000 * iMod)
	Decisions_MAV_Hellenistic_Theatron.Name = "TXT_KEY_EVENT_MATHALX_AZURA_HELLENISTIC_THEATRON_DECISION"
	Decisions_MAV_Hellenistic_Theatron.Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_MATHALX_AZURA_HELLENISTIC_THEATRON_DECISION_DESC", math.ceil(500 * iMod), math.ceil(300 * iMod))
	Decisions_MAV_Hellenistic_Theatron.Weight = 20
	HookDecisionCivilizationIcon(Decisions_MAV_Hellenistic_Theatron, "CIVILIZATION_MATHALX_AZURA_VALLA")
	Decisions_MAV_Hellenistic_Theatron.CanFunc = (
		function(agonistes)

			if agonistes:GetCivilizationType() ~= iVallaCiv then 
				return false, false 
			end

			local bHasFriendlyHellenisticCiv = false

			for jPlayer = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
				paichnides = Players[jPlayer]
				for iKey, civType in pairs(iEligibleCiv) do
					if paichnides:GetCivilizationType() == civType and agonistes:IsDoF(jPlayer) then
						bHasFriendlyHellenisticCiv = true
					end
				end
			end

			if not bHasFriendlyHellenisticCiv then
				return false, false 
			end

			local iCost = math.ceil(500 * iMod)
			local iCultureCost = math.ceil(300 * iMod)

			Decisions_MAV_Hellenistic_Theatron.Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_MATHALX_AZURA_HELLENISTIC_THEATRON_DECISION_DESC", iCost, iCultureCost)

			if load(agonistes, "Decisions_MAV_Hellenistic_Theatron") ~= nil then
				if load(agonistes, "Decisions_MAV_Hellenistic_Theatron") then
					Decisions_MAV_Hellenistic_Theatron.Desc = Locale.ConvertTextKey("TXT_KEY_EVENT_MATHALX_AZURA_HELLENISTIC_THEATRON_DECISION_ENACTED_DESC")
					return false, false, true
				end
			end

			if not Teams[agonistes:GetTeam()]:IsHasTech(GameInfo.Technologies[iDrama].ID) then
				return true, false
			end

			if agonistes:GetGold() < iCost then
				return true, false
			end
			if agonistes:GetJONSCulture() < iCultureCost then
				return true, false
			end
			if agonistes:GetNumResourceAvailable(iMagistrate, false) < 1	 	
				then return true, false 
			end

			return true, true
		end
		)

	Decisions_MAV_Hellenistic_Theatron.DoFunc = (
		function(agonistes)
			agonistes:ChangeNumResourceTotal(iMagistrate, -1)

			local iCost = math.ceil(500 * iMod)
			local iCultureCost = math.ceil(300 * iMod)
			agonistes:ChangeGold(-iCost)
			agonistes:ChangeJONSCulture(-iCultureCost)

			agonistes:ChangeGoldenAgeTurns(math.ceil(12 * iMod))

			if not agonistes:HasPolicy(iHellenisticPolicy) then
				if Player.GrantPolicy then
					agonistes:GrantPolicy(iHellenisticPolicy, true)
				else
					agonistes:SetNumFreePolicies(1)
					agonistes:SetNumFreePolicies(0)
					agonistes:SetHasPolicy(iHellenisticPolicy, true)
				end
			end

			save(agonistes, "Decisions_MAV_Hellenistic_Theatron", true)
		end
	)

Decisions_AddCivilisationSpecific(iVallaCiv, "Decisions_MAV_Hellenistic_Theatron", Decisions_MAV_Hellenistic_Theatron)

function allowHerodeion(iPlayer, iCity, building)
	local agonistes = Players[iPlayer]
	local cities = 0
	if building == iHerodeion then
		return load(agonistes, "Decisions_MAV_Hellenistic_Theatron")
	end
	return true
end

GameEvents.CityCanConstruct.Add(allowHerodeion)

function HerodeionFood(iPlayer)
	local agonistes = Players[iPlayer]
	for asty in agonistes:Cities() do
		if asty:IsHasBuilding(iHerodeion) then
			asty:SetNumRealBuilding(iHerodeionDummy, asty:GetNumGreatWorksInBuilding(iHerodeionClass))
		end
	end
end

GameEvents.PlayerDoTurn.Add(HerodeionFood)